<?php

namespace Proxies;

/**
 * THIS CLASS WAS GENERATED BY THE DOCTRINE ORM. DO NOT EDIT THIS FILE.
 */
class EntitiesLessonProxy extends \Entities\Lesson implements \Doctrine\ORM\Proxy\Proxy
{
    private $_entityPersister;
    private $_identifier;
    public $__isInitialized__ = false;
    public function __construct($entityPersister, $identifier)
    {
        $this->_entityPersister = $entityPersister;
        $this->_identifier = $identifier;
    }
    /** @private */
    public function __load()
    {
        if (!$this->__isInitialized__ && $this->_entityPersister) {
            $this->__isInitialized__ = true;
            if ($this->_entityPersister->load($this->_identifier, $this) === null) {
                throw new \Doctrine\ORM\EntityNotFoundException();
            }
            unset($this->_entityPersister, $this->_identifier);
        }
    }
    
    
    public function id()
    {
        $this->__load();
        return parent::id();
    }

    public function course(\Entities\Course $course = NULL)
    {
        $this->__load();
        return parent::course($course);
    }

    public function addTeacher(\Entities\Teacher $teacher)
    {
        $this->__load();
        return parent::addTeacher($teacher);
    }

    public function teachers()
    {
        $this->__load();
        return parent::teachers();
    }

    public function number($number = NULL)
    {
        $this->__load();
        return parent::number($number);
    }

    public function lessonType($lesson_type = NULL)
    {
        $this->__load();
        return parent::lessonType($lesson_type);
    }

    public function addStudent(\Entities\Student $student)
    {
        $this->__load();
        return parent::addStudent($student);
    }

    public function students()
    {
        $this->__load();
        return parent::students();
    }


    public function __sleep()
    {
        return array('__isInitialized__', 'id', 'course_code', 'course', 'teachers', 'number', 'lesson_type', 'week_day', 'week_parity', 'time_from', 'time_to', 'p_students', 'l_students', 'c_students');
    }

    public function __clone()
    {
        if (!$this->__isInitialized__ && $this->_entityPersister) {
            $this->__isInitialized__ = true;
            $class = $this->_entityPersister->getClassMetadata();
            $original = $this->_entityPersister->load($this->_identifier);
            if ($original === null) {
                throw new \Doctrine\ORM\EntityNotFoundException();
            }
            foreach ($class->reflFields AS $field => $reflProperty) {
                $reflProperty->setValue($this, $reflProperty->getValue($original));
            }
            unset($this->_entityPersister, $this->_identifier);
        }
        
    }
}